;(c)2001 Jindra Gottwald			ct 18:00
;rotace pole s prvky hexa doleva o pulbyte

.MODEL small
.STACK 100h

.DATA
delka	DW 7d				;delka v bytech
data	DB 12h,22h,33h,44h,55h,66h,0ffh
eol	DB 0dh,0ah,'$'
posun	DW 29d				;o kolik pulbytu doleva
pretab	DB '0123456789ABCDEF'		;prevodni tabulka

.CODE
start:	mov ax,@DATA			;init
	mov ds,ax
	xor dx,dx

	cmp delka,0
	jnz dal
	jmp konec

dal:	call near ptr vypis		;vypis neposunuteho

	mov ah,09h			;dalsi radek
	mov dx,offset [eol]
	int 21h

	mov ax,posun
	mov bx,delka
	shl bx,1
	
zmensi:	cmp ax,bx
	jbe vpoho
	sub ax,bx
	jmp zmensi

vpoho:	mov posun,ax
	mov cx,posun
	clc
	rcr cx,1
	cmp cx,0
	jz licho

kernel:	xor si,si			;pro sude
	mov al,data[si]
inside:	mov ah,data[si+1]
	mov data[si],ah
	inc si
	cmp si,delka
	jnz inside
	dec si
	mov data[si],al
	loop kernel

licho:	mov cx,posun			;pro nulu a liche
	clc
	rcr cx,1
	clc
	rcl cx,1
	cmp cx,posun
	jz nula

	mov cx,delka
	xor si,si
	mov al,data[si]
	and al,11110000b
ker2:	mov ah,data[si]
	mov bl,data[si+1]
	and ah,00001111b
	clc
	rcl ah,1
	rcl ah,1
	rcl ah,1
	rcl ah,1
	and bl,11110000b
	rcr bl,1
	rcr bl,1
	rcr bl,1
	rcr bl,1
	add bl,ah
	mov data[si],bl
	inc si
	loop ker2
	dec si
	clc
	rcr al,1
	rcr al,1
	rcr al,1
	rcr al,1
	add al,ah
	mov data[si],al
	
nula:	call near ptr vypis
	jmp konec

tisk	proc near			;procedura vypisu znaku v hexa
	push si
	mov si,dx
	mov dl,pretab[si]
	mov ah,02h
	int 21h
	pop si
	ret
tisk	endp

vypis	proc near			;procedura vypisu dat
	push si
	push cx
	push dx
	push ax
	mov si,0
	mov cx,delka
vypis1:	mov dl,data[si]
	clc
	rcr dl,1
	clc
	rcr dl,1
	clc
	rcr dl,1
	clc
	rcr dl,1
	call near ptr tisk
	mov dl,data[si]
	and dl,00001111b
	call near ptr tisk
	mov dl,' '
	mov ah,02h
	int 21h
	inc si
	loop vypis1
	pop ax
	pop dx
	pop cx
	pop si
	ret
vypis	endp
	
konec:	mov ax,4c00h			;konec
	int 21h
	end start